# Workflow App
The app consists of 2 "features":

## 1. Autotagging

Admin can define a list of conditions which have to be met, and then a Tag is assigned to a file when uploading. The list of conditions is similar to Firewall.

> ![Autotagging](https://cloud.githubusercontent.com/assets/213943/12648203/19a0bb7c-c5d9-11e5-911f-71564c865d0b.png)

## 2. Retention
Admin can define a period of time for each tag. A daily background job deletes all files or subfiles which are older than the period and have the tag set on a parent or themselves.
Available options:

* Days
* Weeks (is replaced with 7 Days while storing)
* Months
* Years

> ![Retention](https://cloud.githubusercontent.com/assets/213943/12648080/86292154-c5d8-11e5-9d42-dff826d89711.png)

## QA metrics

### QA metrics on master branch:

[![Build Status](https://magnum.travis-ci.com/owncloud/workflow.svg?token=q8ZoWBCat8DFpZ2ALfXP&branch=master)](https://magnum.travis-ci.com/owncloud/workflow)

[![Scrutinizer Code Quality](https://scrutinizer-ci.com/g/owncloud/workflow/badges/quality-score.png?b=master&s=e98a988455dfbc5a30700377e32d4c2182fee5cc)](https://scrutinizer-ci.com/g/owncloud/workflow/?branch=master)

[![Code Coverage](https://scrutinizer-ci.com/g/owncloud/workflow/badges/coverage.png?b=master&s=1eebef86dc4bbab8a29cfb4cadc0480a8f46f0a2)](https://scrutinizer-ci.com/g/owncloud/workflow/?branch=master)

### QA metrics on stable9.1 branch:

[![Build Status](https://magnum.travis-ci.com/owncloud/workflow.svg?token=q8ZoWBCat8DFpZ2ALfXP&branch=stable9.1)](https://magnum.travis-ci.com/owncloud/workflow)

[![Scrutinizer Code Quality](https://scrutinizer-ci.com/g/owncloud/workflow/badges/quality-score.png?b=stable9.1&s=e98a988455dfbc5a30700377e32d4c2182fee5cc)](https://scrutinizer-ci.com/g/owncloud/workflow/?branch=stable9.1)

[![Code Coverage](https://scrutinizer-ci.com/g/owncloud/workflow/badges/coverage.png?b=stable9.1&s=1eebef86dc4bbab8a29cfb4cadc0480a8f46f0a2)](https://scrutinizer-ci.com/g/owncloud/workflow/?branch=stable9.1)

### QA metrics on stable9 branch:

[![Build Status](https://magnum.travis-ci.com/owncloud/workflow.svg?token=q8ZoWBCat8DFpZ2ALfXP&branch=stable9)](https://magnum.travis-ci.com/owncloud/workflow)

[![Scrutinizer Code Quality](https://scrutinizer-ci.com/g/owncloud/workflow/badges/quality-score.png?b=stable9&s=e98a988455dfbc5a30700377e32d4c2182fee5cc)](https://scrutinizer-ci.com/g/owncloud/workflow/?branch=stable9)

[![Code Coverage](https://scrutinizer-ci.com/g/owncloud/workflow/badges/coverage.png?b=stable9&s=1eebef86dc4bbab8a29cfb4cadc0480a8f46f0a2)](https://scrutinizer-ci.com/g/owncloud/workflow/?branch=stable9)
